<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>CppModelElementsCreator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/cpp/codegen/transformation/CppModelElementsCreator.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2006 - 2012 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.transformation;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.CCorePlugin;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.ToolFactory;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.cdt.core.formatter.CodeFormatter;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IProject;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IProgressMonitor;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Platform;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.BadLocationException;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.Document;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.text.IDocument;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.ModelElementsCreator;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.Activator;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.Constants;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.Messages;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.preferences.CppCodeGenUtils;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppClassifierGenerator;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.codegen.xtend.CppPackageHeaderGenerator;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.ExternLibrary;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.External;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Include;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.ManualGeneration;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.NoCodeGen;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.cpp.profile.C_Cpp.Template;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.tools.file.IPFileSystemAccess;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.tools.file.ProjectBasedFileAccess;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.text.edits.MalformedTreeException;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.text.edits.TextEdit;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Association;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageableElement;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PrimitiveType;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Relationship;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Signal;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.SignalEvent;
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Usage;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment"> * Main class of C++ code generator</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment"> * @author Ansgar Radermacher (ansgar.radermacher@cea.fr)</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment"> * @author Önder GÜRCAN (onder.gurcan@cea.fr)</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/transformation/CppModelElementsCreator.html">CppModelElementsCreator</a> <strong class="jxr_keyword">extends</strong> ModelElementsCreator {
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String LANGUAGE_NAME = <span class="jxr_string">"C++"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	<strong class="jxr_keyword">protected</strong> String sourceFolder;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">	 * Constructor.</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 * @param project</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 *            the project in which the generated code should be placed</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/transformation/CppModelElementsCreator.html">CppModelElementsCreator</a>(IProject project) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		<strong class="jxr_keyword">this</strong>(<strong class="jxr_keyword">new</strong> ProjectBasedFileAccess(project), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">this</strong>.project = project;
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 * Constructor, allows for non-standard commentHeader</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 * @param project</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 *            the project in which the generated code should be placed</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 * @param commentHeader</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 *            Custom prefix for each generated file</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/transformation/CppModelElementsCreator.html">CppModelElementsCreator</a>(IProject project, String commentHeader) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		<strong class="jxr_keyword">this</strong>(<strong class="jxr_keyword">new</strong> ProjectBasedFileAccess(project), commentHeader);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<strong class="jxr_keyword">this</strong>.project = project;
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	}
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 * Constructor. Pass caller defined file system access and commentHeader</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 * @param project</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 *            the project in which the generated code should be placed</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 * @param commentHeader</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 *            commentHeader. If null, take from preferences</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/transformation/CppModelElementsCreator.html">CppModelElementsCreator</a>(IPFileSystemAccess fileSystemAccess, String commentHeader) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">super</strong>(fileSystemAccess, <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/cpp/codegen/transformation/CppLocationStrategy.html">CppLocationStrategy</a>(), LANGUAGE_NAME);
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<strong class="jxr_keyword">this</strong>.commentHeader = (commentHeader != <strong class="jxr_keyword">null</strong>) ?
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 				commentHeader :
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 				CppCodeGenUtils.getCommentHeader();
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		hppExt = CppCodeGenUtils.getHeaderSuffix();
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		cppExt = CppCodeGenUtils.getBodySuffix();
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		sourceFolder = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 	}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 	<strong class="jxr_keyword">protected</strong> String hppExt;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 	<strong class="jxr_keyword">protected</strong> String cppExt;
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 	<strong class="jxr_keyword">protected</strong> String commentHeader;
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> <em class="jxr_javadoccomment">	 * Creates the files corresponding to the class. For a "simple" class</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> <em class="jxr_javadoccomment">	 * generates 2 headers (one for the privates concrete operations and one for</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> <em class="jxr_javadoccomment">	 * the attributes, public operations and virtual / abstract operations and</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 * one body file.</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 * @param folder</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 * @param classifier</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> <em class="jxr_javadoccomment">	 * @throws CoreException</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 	@Override
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> createPackageableElementFile(PackageableElement element, IProgressMonitor monitor) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		<strong class="jxr_keyword">if</strong> (sourceFolder == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			sourceFolder = GenUtils.getSourceFolder(element);
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		<strong class="jxr_keyword">if</strong> (element instanceof Package) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			generatePkg((Package) element);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> ((element instanceof PrimitiveType) || (element instanceof Enumeration) || (element instanceof Usage)) {
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			<em class="jxr_comment">// do nothing, included in package</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		}
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (element instanceof Classifier) {
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 			generateClassifier((Classifier) element);
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		}
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (element instanceof Relationship) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 			<em class="jxr_comment">// no code generation for relationships</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		}
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (element instanceof Signal) {
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			<em class="jxr_comment">// TODO: not supported, but do nothing</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		}
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (element instanceof SignalEvent) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 			<em class="jxr_comment">// TODO: not supported, but do nothing</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		}
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			Activator.log.debug(<span class="jxr_string">"C++ code generator: unsupported model element "</span> + element); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 	}
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> generateClassifier(Classifier classifier) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 			
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<em class="jxr_comment">// treat case of manual code generation</em>
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		<strong class="jxr_keyword">if</strong> (GenUtils.hasStereotype(classifier, ManualGeneration.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			<strong class="jxr_keyword">final</strong> ManualGeneration mg = UMLUtil.getStereotypeApplication(classifier, ManualGeneration.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 			<strong class="jxr_keyword">final</strong> Include cppInclude = UMLUtil.getStereotypeApplication(classifier, Include.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 			<strong class="jxr_keyword">final</strong> String fileContentH = commentHeader + cppInclude.getHeader();
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 			<em class="jxr_comment">// generate header code</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 			<strong class="jxr_keyword">final</strong> String fileNameH = locStrategy.getFileName(classifier) + Constants.DOT + hppExt;
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			generateFile(fileNameH, fileContentH);
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			<em class="jxr_comment">// generate body code</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 			String fileContentB = commentHeader +
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 					cppInclude.getPreBody() + GenUtils.NL +
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 					cppInclude.getBody() + GenUtils.NL;
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 			String ext = GenUtils.maskNull(mg.getExtensionBody());
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 			<strong class="jxr_keyword">if</strong> (ext.length() == 0) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 				ext = cppExt;
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			}
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			String fileNameB = locStrategy.getFileName(classifier) + Constants.DOT + ext;
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			generateFile(fileNameB, fileContentB);
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		}
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		<em class="jxr_comment">// Only generate when no CppNoCodeGen stereotype is applied to the class</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> ((!noCodeGen(classifier)) &amp;&amp; (!GenUtils.hasStereotype(classifier, Template.<strong class="jxr_keyword">class</strong>)) &amp;&amp;
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 				(!(classifier instanceof Association))) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			<em class="jxr_comment">// Template Bound Class</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 			<strong class="jxr_keyword">if</strong> (GenUtils.isTemplateBoundElement(classifier)) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 				<strong class="jxr_keyword">final</strong> String bindHeaderFileName = locStrategy.getFileName(classifier) + Constants.DOT + hppExt;
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 				generateFile(bindHeaderFileName, commentHeader + CppClassifierGenerator.generateBindHeaderCode(classifier));
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 				<strong class="jxr_keyword">final</strong> String bindBodyFileName = locStrategy.getFileName(classifier) + Constants.DOT + cppExt;
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 				generateFile(bindBodyFileName, commentHeader + CppClassifierGenerator.generateBindBodyCode(classifier));
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 			}
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 				<em class="jxr_comment">// Class Header file generation</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 				<strong class="jxr_keyword">final</strong> String classHeaderFileName = locStrategy.getFileName(classifier) + Constants.DOT + hppExt;
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 				generateFile(classHeaderFileName, commentHeader + CppClassifierGenerator.generateClassHeaderCode(classifier));
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 				<em class="jxr_comment">// Class Body file generation</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 				<strong class="jxr_keyword">if</strong> (classifier instanceof Class) {
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 					<strong class="jxr_keyword">final</strong> String classBodyFileName = locStrategy.getFileName(classifier) + Constants.DOT + cppExt;
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 					generateFile(classBodyFileName, commentHeader + CppClassifierGenerator.generateClassBodyCode(classifier));
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 				}
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 			}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		}
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	}
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> generatePkg(Package pkg) {
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 		<strong class="jxr_keyword">final</strong> String fileName = locStrategy.getFileName(pkg) + Constants.DOT + hppExt;
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 		generateFile(fileName, CppPackageHeaderGenerator.generateCode(pkg).toString());
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 	}
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> generateFile(String fileName, String content) {
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 		fileSystemAccess.generateFile(sourceFolder + fileName, format(content));
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 	}
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L219" href="#L219">219</a> <em class="jxr_javadoccomment">	 * Apply the user's currently selected formatting options to the input content. Return the</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> <em class="jxr_javadoccomment">	 * input String in case of error.</em>
<a class="jxr_linenumber" name="L221" href="#L221">221</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String format(String content) {
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 		<em class="jxr_comment">// do nothing if the CDT plugin is not loaded</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		<strong class="jxr_keyword">if</strong> (Platform.getBundle(CCorePlugin.PLUGIN_ID) == <strong class="jxr_keyword">null</strong>)
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 			<strong class="jxr_keyword">return</strong> content;
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 		CodeFormatter codeFormatter = ToolFactory.createCodeFormatter(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 		IDocument doc = <strong class="jxr_keyword">new</strong> Document(content);
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		TextEdit edit = codeFormatter.format(CodeFormatter.K_TRANSLATION_UNIT, doc.get(), 0, doc.get().length(), 0, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 		<strong class="jxr_keyword">if</strong> (edit == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			Activator.log.debug(Messages.CppModelElementsCreator_CannotFormatContent);
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			<strong class="jxr_keyword">return</strong> content;
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 		}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 			edit.apply(doc);
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 			<strong class="jxr_keyword">return</strong> doc.get();
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		} <strong class="jxr_keyword">catch</strong> (MalformedTreeException e) {
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 			Activator.log.error(e);
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 		} <strong class="jxr_keyword">catch</strong> (BadLocationException e) {
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 			Activator.log.error(e);
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		}
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		<strong class="jxr_keyword">return</strong> content;
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 	}
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> noCodeGen(Element element) {
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		<strong class="jxr_keyword">if</strong> (GenUtils.hasStereotype(element, NoCodeGen.<strong class="jxr_keyword">class</strong>) ||
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 				GenUtils.hasStereotype(element, External.<strong class="jxr_keyword">class</strong>) ||
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 				GenUtils.hasStereotypeTree(element, ExternLibrary.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 		}
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">super</strong>.noCodeGen(element);
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 	}
<a class="jxr_linenumber" name="L257" href="#L257">257</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
